/***************************************************************************
                          astar.h  -  description
                             -------------------
    begin                : Wed Nov 14 2001
    copyright            : (C) 2001 by Jos Pablo Fernndez
    email                : jpablo@di.uc3m.es
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef ASTAR_H
#define ASTAR_H


/**
  *@author Jos Pablo Fernndez
  */

#include "astardata.h"
#include "tree.h"
#include "milist.h"



class AStar   {
public: 
	AStar();
	AStar(AStarData &data);	
	~AStar();
	void init(AStarData *data);
	bool resolve(int process=-1) ;
	Tree<AStarData> *best() ;

private:
	AStarData *data ;
	Tree<AStarData> *tree ;

	Tree<AStarData> *the_best ;	
	int min_h ;
	MiList A ;
	MiList solution ;
	
	bool sucess ;
	int tot_process ;
};

#endif
